<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="pt"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>UserJWTController.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Credenciamento</a> &gt; <a href="index.source.html" class="el_package">br.edu.unifacisa.lti.web.rest</a> &gt; <span class="el_source">UserJWTController.java</span></div><h1>UserJWTController.java</h1><pre class="source lang-java linenums">package br.edu.unifacisa.lti.web.rest;

import br.edu.unifacisa.lti.security.jwt.JWTConfigurer;
import br.edu.unifacisa.lti.security.jwt.TokenProvider;
import br.edu.unifacisa.lti.web.rest.vm.LoginVM;

import java.util.Collections;

import com.codahale.metrics.annotation.Timed;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.security.authentication.AuthenticationManager;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;

@RestController
@RequestMapping(&quot;/api&quot;)
public class UserJWTController {

<span class="fc" id="L29">    private final Logger log = LoggerFactory.getLogger(UserJWTController.class);</span>

    private final TokenProvider tokenProvider;

    private final AuthenticationManager authenticationManager;

<span class="fc" id="L35">    public UserJWTController(TokenProvider tokenProvider, AuthenticationManager authenticationManager) {</span>
<span class="fc" id="L36">        this.tokenProvider = tokenProvider;</span>
<span class="fc" id="L37">        this.authenticationManager = authenticationManager;</span>
<span class="fc" id="L38">    }</span>

    @PostMapping(&quot;/authenticate&quot;)
    @Timed
    public ResponseEntity authorize(@Valid @RequestBody LoginVM loginVM, HttpServletResponse response) {

<span class="nc" id="L44">        UsernamePasswordAuthenticationToken authenticationToken =</span>
<span class="nc" id="L45">            new UsernamePasswordAuthenticationToken(loginVM.getUsername(), loginVM.getPassword());</span>

        try {
<span class="nc" id="L48">            Authentication authentication = this.authenticationManager.authenticate(authenticationToken);</span>
<span class="nc" id="L49">            SecurityContextHolder.getContext().setAuthentication(authentication);</span>
<span class="nc bnc" id="L50" title="All 2 branches missed.">            boolean rememberMe = (loginVM.isRememberMe() == null) ? false : loginVM.isRememberMe();</span>
<span class="nc" id="L51">            String jwt = tokenProvider.createToken(authentication, rememberMe);</span>
<span class="nc" id="L52">            response.addHeader(JWTConfigurer.AUTHORIZATION_HEADER, &quot;Bearer &quot; + jwt);</span>
<span class="nc" id="L53">            return ResponseEntity.ok(new JWTToken(jwt));</span>
<span class="nc" id="L54">        } catch (AuthenticationException ae) {</span>
<span class="nc" id="L55">            log.trace(&quot;Authentication exception trace: {}&quot;, ae);</span>
<span class="nc" id="L56">            return new ResponseEntity&lt;&gt;(Collections.singletonMap(&quot;AuthenticationException&quot;,</span>
<span class="nc" id="L57">                ae.getLocalizedMessage()), HttpStatus.UNAUTHORIZED);</span>
        }
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.7.9.201702052155</span></div></body></html>